# LinkedListQueue | data-structure-typed
Documentation for data-structure-typed

# Class LinkedListQueue<T>

#### Type Parameters

- #### T = any

#### Hierarchy

- SinglyLinkedList <T>
  - LinkedListQueue

- Defined in src/data-structures/queue/queue.ts:8

#####
Index

### Constructors

constructor

### Accessors

head
length
tail

### Methods

[iterator]
clear
countOccurrences
delete
deleteAt
dequeue
enqueue
find
findNode
getAt
getLength
getNodeAt
indexOf
insertAfter
insertAt
insertBefore
isEmpty
peek
pop
push
reverse
shift
toArray
unshift
fromArray

## Constructors

### constructor

- new LinkedListQueue<T>(): LinkedListQueue <T>

- The constructor initializes the linked list with an empty head, tail, and length.

  #### Type Parameters

  - #### T = any

  #### Returns LinkedListQueue <T>

  Inherited from SinglyLinkedList.constructor

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:44

## Accessors

### head

- get head(): null | SinglyLinkedListNode <T>

- #### Returns null | SinglyLinkedListNode <T>

  Inherited from SinglyLinkedList.head

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:52
- set head(value): void

- #### Parameters

  - ##### value: null | SinglyLinkedListNode <T>

  #### Returns void

  Inherited from SinglyLinkedList.head

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:56

### length

- get length(): number

- #### Returns number

  Inherited from SinglyLinkedList.length

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:72

### tail

- get tail(): null | SinglyLinkedListNode <T>

- #### Returns null | SinglyLinkedListNode <T>

  Inherited from SinglyLinkedList.tail

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:62
- set tail(value): void

- #### Parameters

  - ##### value: null | SinglyLinkedListNode <T>

  #### Returns void

  Inherited from SinglyLinkedList.tail

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:66

## Methods

### [iterator]

- [iterator](): Generator<T, void, unknown>

- #### Returns Generator<T, void, unknown>

  Inherited from SinglyLinkedList.[iterator]

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:493

### clear

- clear(): void

- The `clear` function resets the linked list by setting the head, tail, and length to null and 0 respectively.

  #### Returns void

  Inherited from SinglyLinkedList.clear

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:300

### countOccurrences

- countOccurrences(value): number

- The function counts the number of occurrences of a given value in a linked list.

  #### Parameters

  - ##### value: T

    The value parameter is the value that you want to count the occurrences of in the linked list.

  #### Returns number

  The count of occurrences of the given value in the linked list.

  Inherited from SinglyLinkedList.countOccurrences

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:479

### delete

- delete(valueOrNode): boolean

- The delete function removes a node with a specific value from a singly linked list.

  #### Parameters

  - ##### valueOrNode: T

    The `valueOrNode` parameter can accept either a value of type `T` or a `SinglyLinkedListNode<T>` object.

  #### Returns boolean

  The `delete` method returns a boolean value. It returns `true` if the value or node is found and successfully deleted from the linked list, and `false` if the value or node is not found in the linked list.

  Inherited from SinglyLinkedList.delete

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:217
- delete(valueOrNode): boolean

- The delete function removes a node with a specific value from a singly linked list.

  #### Parameters

  - ##### valueOrNode: SinglyLinkedListNode <T>

    The `valueOrNode` parameter can accept either a value of type `T` or a `SinglyLinkedListNode<T>` object.

  #### Returns boolean

  The `delete` method returns a boolean value. It returns `true` if the value or node is found and successfully deleted from the linked list, and `false` if the value or node is not found in the linked list.

  Inherited from SinglyLinkedList.delete

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:218

### deleteAt

- deleteAt(index): undefined | T

- The `deleteAt` function removes an element at a specified index from a linked list and returns the removed element.

  #### Parameters

  - ##### index: number

    The index parameter represents the position of the element that needs to be deleted in the data structure. It is of type number.

  #### Returns undefined | T

  The method `deleteAt` returns the value of the node that was deleted, or `null` if the index is out of bounds.

  Inherited from SinglyLinkedList.deleteAt

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:205

### dequeue

- dequeue(): undefined | T

- The `dequeue` function removes and returns the first element from a queue, or returns null if the queue is empty.

  #### Returns undefined | T

  The method is returning the element at the front of the queue, or null if the queue is empty.

  - Defined in src/data-structures/queue/queue.ts:21

### enqueue

- enqueue(value): void

- The enqueue function adds a value to the end of an array.

  #### Parameters

  - ##### value: T

    The value parameter represents the value that you want to add to the queue.

  #### Returns void

  - Defined in src/data-structures/queue/queue.ts:13

### find

- find(callback): null | T

- The `find` function iterates through a linked list and returns the first element that satisfies a given condition.

  #### Parameters

  - ##### callback: ((val) => boolean)

    A function that takes a value of type T as its parameter and returns a boolean value. This function is used to determine whether a particular value in the linked list satisfies a certain condition.

    - - (val): boolean

      - #### Parameters

        - ##### val: T

        #### Returns boolean

  #### Returns null | T

  The method `find` returns the first element in the linked list that satisfies the condition specified by the callback function. If no element satisfies the condition, it returns `null`.

  Inherited from SinglyLinkedList.find

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:348

### findNode

- findNode(value): null | SinglyLinkedListNode <T>

- The function finds a node in a singly linked list by its value and returns the node if found, otherwise returns null.

  #### Parameters

  - ##### value: T

    The value parameter is the value that we want to search for in the linked list.

  #### Returns null | SinglyLinkedListNode <T>

  a `SinglyLinkedListNode<T>` if a node with the specified value is found in the linked list. If no node with the specified value is found, the function returns `null`.

  Inherited from SinglyLinkedList.findNode

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:387

### getAt

- getAt(index): undefined | T

- The function `getAt` returns the value at a specified index in a linked list, or null if the index is out of range.

  #### Parameters

  - ##### index: number

    The index parameter is a number that represents the position of the element we want to retrieve from the list.

  #### Returns undefined | T

  The method `getAt(index: number): T | null` returns the value at the specified index in the linked list, or `null` if the index is out of bounds.

  Inherited from SinglyLinkedList.getAt

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:174

### getLength

- getLength(): number

- #### Returns number

  Inherited from SinglyLinkedList.getLength

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:90

### getNodeAt

- getNodeAt(index): null | SinglyLinkedListNode <T>

- The function `getNodeAt` returns the node at a given index in a singly linked list.

  #### Parameters

  - ##### index: number

    The `index` parameter is a number that represents the position of the node we want to retrieve from the linked list. It indicates the zero-based index of the node we want to access.

  #### Returns null | SinglyLinkedListNode <T>

  The method `getNodeAt(index: number)` returns a `SinglyLinkedListNode<T>` object if the node at the specified index exists, or `null` if the index is out of bounds.

  Inherited from SinglyLinkedList.getNodeAt

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:190

### indexOf

- indexOf(value): number

- The `indexOf` function returns the index of the first occurrence of a given value in a linked list.

  #### Parameters

  - ##### value: T

    The value parameter is the value that you want to find the index of in the linked list.

  #### Returns number

  The method is returning the index of the first occurrence of the specified value in the linked list. If the value is not found, it returns -1.

  Inherited from SinglyLinkedList.indexOf

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:365

### insertAfter

- insertAfter(existingValueOrNode, newValue): boolean

- The `insertAfter` function inserts a new node with a given value after an existing node in a singly linked list.

  #### Parameters

  - ##### existingValueOrNode: T

    The existing value or node in the linked list after which the new value will be inserted. It can be either the value of the existing node or the existing node itself.

  - ##### newValue: T

    The value that you want to insert into the linked list after the existing value or node.

  #### Returns boolean

  The method returns a boolean value. It returns true if the new value was successfully inserted after the existing value or node, and false if the existing value or node was not found in the linked list.

  Inherited from SinglyLinkedList.insertAfter

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:440
- insertAfter(existingValueOrNode, newValue): boolean

- The `insertAfter` function inserts a new node with a given value after an existing node in a singly linked list.

  #### Parameters

  - ##### existingValueOrNode: SinglyLinkedListNode <T>

    The existing value or node in the linked list after which the new value will be inserted. It can be either the value of the existing node or the existing node itself.

  - ##### newValue: T

    The value that you want to insert into the linked list after the existing value or node.

  #### Returns boolean

  The method returns a boolean value. It returns true if the new value was successfully inserted after the existing value or node, and false if the existing value or node was not found in the linked list.

  Inherited from SinglyLinkedList.insertAfter

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:441

### insertAt

- insertAt(index, val): boolean

- The `insertAt` function inserts a value at a specified index in a singly linked list.

  #### Parameters

  - ##### index: number

    The index parameter represents the position at which the new value should be inserted in the linked list. It is of type number.

  - ##### val: T

    The `val` parameter represents the value that you want to insert into the linked list at the specified index.

  #### Returns boolean

  The `insert` method returns a boolean value. It returns `true` if the insertion is successful, and `false` if the index is out of bounds.

  Inherited from SinglyLinkedList.insertAt

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:269

### insertBefore

- insertBefore(existingValue, newValue): boolean

- The `insertBefore` function inserts a new value before an existing value in a singly linked list.

  #### Parameters

  - ##### existingValue: T

  - ##### newValue: T

    The `newValue` parameter represents the value that you want to insert into the linked list.

  #### Returns boolean

  The method `insertBefore` returns a boolean value. It returns `true` if the new value was successfully inserted before the existing value, and `false` otherwise.

  Inherited from SinglyLinkedList.insertBefore

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:400
- insertBefore(existingValue, newValue): boolean

- The `insertBefore` function inserts a new value before an existing value in a singly linked list.

  #### Parameters

  - ##### existingValue: SinglyLinkedListNode <T>

  - ##### newValue: T

    The `newValue` parameter represents the value that you want to insert into the linked list.

  #### Returns boolean

  The method `insertBefore` returns a boolean value. It returns `true` if the new value was successfully inserted before the existing value, and `false` otherwise.

  Inherited from SinglyLinkedList.insertBefore

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:401

### isEmpty

- isEmpty(): boolean

- The function checks if the length of a data structure is equal to zero and returns a boolean value indicating whether it is empty or not.

  #### Returns boolean

  A boolean value indicating whether the length of the object is equal to 0.

  Inherited from SinglyLinkedList.isEmpty

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:293

### peek

- peek(): undefined | T

- The `peek` function returns the value of the head node in a linked list, or `undefined` if the list is empty.

  #### Returns undefined | T

  The `peek()` method is returning the value of the `head` node if it exists, otherwise it returns `undefined`.

  - Defined in src/data-structures/queue/queue.ts:29

### pop

- pop(): undefined | T

- The `pop()` function removes and returns the value of the last element in a linked list, updating the head and tail pointers accordingly.

  #### Returns undefined | T

  The method `pop()` returns the value of the node that is being removed from the end of the linked list. If the linked list is empty, it returns `null`.

  Inherited from SinglyLinkedList.pop

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:117

### push

- push(data): void

- The `push` function adds a new node with the given data to the end of a singly linked list.

  #### Parameters

  - ##### data: T

    The "data" parameter represents the value that you want to add to the linked list. It can be of any type (T) as specified in the generic type declaration of the class or function.

  #### Returns void

  Inherited from SinglyLinkedList.push

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:99

### reverse

- reverse(): void

- The `reverse` function reverses the order of the nodes in a singly linked list.

  #### Returns void

  The reverse() method does not return anything. It has a return type of void.

  Inherited from SinglyLinkedList.reverse

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:324

### shift

- shift(): undefined | T

- The `shift()` function removes and returns the value of the first node in a linked list.

  #### Returns undefined | T

  The value of the node that is being removed from the beginning of the linked list.

  Inherited from SinglyLinkedList.shift

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:142

### toArray

- toArray(): T[]

- The `toArray` function converts a linked list into an array.

  #### Returns T[]

  The `toArray()` method is returning an array of type `T[]`.

  Inherited from SinglyLinkedList.toArray

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:310

### unshift

- unshift(val): void

- The unshift function adds a new node with the given value to the beginning of a singly linked list.

  #### Parameters

  - ##### val: T

    The parameter "val" represents the value of the new node that will be added to the beginning of the linked list.

  #### Returns void

  Inherited from SinglyLinkedList.unshift

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:155

### `Static` fromArray

- fromArray<T>(data): SinglyLinkedList <T>

- The `fromArray` function creates a new SinglyLinkedList instance and populates it with the elements from the given array.

  #### Type Parameters

  - #### T

  #### Parameters

  - ##### data: T[]

    The `data` parameter is an array of elements of type `T`.

  #### Returns SinglyLinkedList <T>

  The `fromArray` function returns a `SinglyLinkedList` object.

  Inherited from SinglyLinkedList.fromArray

  - Defined in src/data-structures/linked-list/singly-linked-list.ts:82

Generated using TypeDoc